




















( // DOUBLE CLICK here, then run the whole process as a 1.do task
{1.do{

	//Set up audio interface
	o = Server.default.options;
	o.memSize = 130672;
	//o.device = "MOTU UltraLite mk3 Hybrid";
	//o.device = "Avid Mbox Mini";
	//o.device = "Scarlett 18i8 USB";



	s.reboot;


	1.wait;

	//retrieve audio files from the directory

	~paths = [

		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_1.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_2.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_3.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_4.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_5.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_6.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_7.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_8.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_9.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_10.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_11.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_12.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_13.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_14.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_15.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_16.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_17.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_18.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_19.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_20.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_21.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_22.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_23.aif",
		"/Users/tploymeneas/Documents/Sussex/PHD/Experiments/Experiment 3/SC/SC-Voice-Joystick/Stephanie Samples/Stephanie Samples/Audio Files/Samples-1/Stephanie Samples_24.aif"

	];




	1.wait;

	//set a buffer per audio file

	(
		~buffers = [];
		c = Condition.new;
		{~paths.do{|item|
			c.test=false;
			~buffers = ~buffers.add(Buffer.read(s, item, action: {c.test = true; c.signal}).postln);
			c.wait;}}.fork;
	);

	1.wait;

	//	//----------------------Ndefs--> SynthDefs: The Synthesizers:








	//4 sines oscilators (synthesizers)
	SynthDef(\osc,
		{
			arg vol = 0, mul = 0.05, gate = 0, gate2 =0, freq = 100, rate =1; //mul was 0.1

			var osc, out, env, env2, signal;

			osc = SinOsc.ar(freq, 0, (SinOsc.ar(rate) * mul) + vol);

			env = EnvGen.ar(Env.asr(5,1,10), gate, doneAction: 0);

			env2 = EnvGen.ar(Env.asr(3,1,10), gate2, doneAction: 0);

			signal = env * osc * env2;

			out = Out.ar(0, Pan2.ar(signal, SinOsc.ar(Rand(0.01,1))));
		}
	).add;



	SynthDef(\osc2,
		{
			arg vol = 0, mul = 0.05, gate = 0, gate2 =0, freq = 100, rate =1; //mul was 0.1

			var osc, out, env, env2, signal;

			osc = SinOsc.ar(freq, 0, (SinOsc.ar(rate) * mul) + vol);

			env = EnvGen.ar(Env.asr(5,1,10), gate, doneAction: 0);

			env2 = EnvGen.ar(Env.asr(3,1,10), gate2, doneAction: 0);

			signal =env *osc * env2;

			out = Out.ar(0, Pan2.ar(signal, SinOsc.ar(Rand(0.01,1))));
		}
	).add;


	SynthDef(\osc3,
		{
			arg vol = 0, mul = 0.05, gate = 0, gate2 =0, freq = 100, rate =1; //mul was 0.1

			var osc, out, env, env2, signal;

			osc = SinOsc.ar(freq, 0, (SinOsc.ar(rate) * mul) + vol);

			env = EnvGen.ar(Env.asr(5,1,10), gate, doneAction: 0);

			env2 = EnvGen.ar(Env.asr(3,1,10), gate2, doneAction: 0);

			signal = env * osc * env2;

			out = Out.ar(0, Pan2.ar(signal, SinOsc.ar(Rand(0.01,1))));
		}
	).add;


	SynthDef(\osc4,
		{
			arg vol = 0, mul = 0.05, gate = 0, gate2 =0, freq = 100, rate =1; //mul was 0.05

			var osc, out, env, env2, signal;

			osc = SinOsc.ar(freq, 0, (SinOsc.ar(rate) * mul) + vol);

			env = EnvGen.ar(Env.asr(5,1,10), gate, doneAction: 0);

			env2 = EnvGen.ar(Env.asr(3,1,10), gate2, doneAction: 0);

			signal = env * osc * env2;

			out = Out.ar(0, Pan2.ar(signal, SinOsc.ar(Rand(0.01,1))));
		}
	).add;


	//Synthesizer: low freqs (bowed)


	(
		SynthDef(\drone1,{

			arg mix = 1, room = 3, damp = 5, freq = 40, freq2= 30, gate = 1, amp = 0, attackSpeed = 80; //amp was 0.6, now 0, 0.6 in args below

			var verb, duster, filter, env, out;

			duster = Dust.ar(
				attackSpeed,
				1);

			filter = (DynKlank.ar(`[
				Array.series(12, Rand(20,100) , Rand(20, 100)),
				Array.geom(12,1,Rand(0.7,0.9)),
				Array.fill(12, {Rand(1.0,3.0)})
			], duster) * 0.2).softclip;

			verb = FreeVerb.ar(
				filter,
				mix,
				room,
				damp);

			env = EnvGen.ar(Env.asr(Rand(5,8), 0.5, Rand(5,8)), gate, doneAction:2);

			env = env * (verb * amp);

			out = Out.ar(0, env !2);

		}).add;
	);






	//Synthesizer: clicks_1 (Feedback synth)

	SynthDef(\clicks_1, {

		arg out = 30, in = 30, freq1 = 1600, freq2=635, rate = 1, oscVol =1, vol= 1, feedbackVol =1, gate =1, panRate=0.1, roomSize =100, gate2 =1;

		var sound;
		var oscs;
		var pan;
		var input;
		var filter;
		var comp;
		var env;
		var env2;




		input = InFeedback.ar(in, 1) * feedbackVol;

		oscs = (SinOsc.ar((freq1 + freq2 )/2, input) * SinOsc.ar([freq1, freq2], input, Dust.kr(rate).max(0) * oscVol))/*.fold2(Line.kr(0,1.01,8))*/;

		sound = GVerb.ar(oscs,roomSize, 5, 0.1);


		pan = Pan2.ar(sound, SinOsc.ar(panRate));


		env =EnvGen.ar(Env.asr(5, 1, 5),gate) ;

		env2 =EnvGen.ar(Env.asr(10, 1, 10),gate2, doneAction:2) ;

		filter = BPF.ar(pan, (freq1+freq2));

		comp = Compander.ar(filter, 0, 0.1, clampTime: 0.0001);


		Out.ar(out, Limiter.ar(comp *vol *env* env2 * 1, 0.9)); //* previously 2 in the amp, now 1


	}).send;

	//bus/synth required for feedback
	SynthDef("bus_stereo_1", { arg out=0, in=30;

		var signal;

		signal = In.ar([in, in+1]);

		Out.ar(out, signal);

	}).add;


	//
	//~bus_clicks_1 = Synth("bus_stereo_1"); //execute first and let running
	//~clicks_1 = Synth(\clicks_1);




	// Synthesizer: clicks_2 (Feedback synth)
	SynthDef(\clicks_2, {

		arg out = 32, in = 32, freq = 1300, rate = 1, oscVol =1, vol= 1, feedbackVol =1, gate =1, panRate=0.1, roomSize =100, gate2=1;

		var sound;
		var oscs;
		var pan;
		var input;
		var filter;
		var comp;
		var env;
		var env2;



		input = InFeedback.ar(in, 1) * feedbackVol;

		oscs = SinOsc.ar(freq, input, Dust.kr(rate).max(0) * 0.8).fold2(Line.kr(0,1.01,8));

		sound = GVerb.ar(oscs,roomSize, 5, 0.1);

		pan = Pan2.ar(sound, SinOsc.ar(panRate));

		env =EnvGen.ar(Env.asr(5, 1, 5),gate) ;

		env2 =EnvGen.ar(Env.asr(10, 1, 10),gate2, doneAction:2) ;

		filter = BPF.ar(pan, freq);

		comp = Compander.ar(filter, 0, 0.1, clampTime: 0.0001);


		Out.ar(out, Limiter.ar(comp *vol *env* env2* 1, 0.9)); //* previously 2 in the amp, now 1

	}).add;


	//bus/synth required for feedback
	SynthDef("bus_stereo_2", { arg out=0, in=32;

		var signal;

		signal = In.ar([in, in+1]);

		Out.ar(out, signal);

	}).add;


	//
	//~bus_clicks_2 = Synth("bus_stereo_2"); //execute first and let running
	//~clicks_2= Synth(\clicks_2);








	//Synthesizer: clicks_3 (Feedback synth)



	SynthDef(\clicks_3, { arg out=34, in=34, freq =1300, rate =1, vol=0.09, feedbackVol =24, gate =1, panRate=0.1, gate2 =1;
		var input, sound, env, env2;
		input = InFeedback.ar(in, 1) * feedbackVol;
		sound = GVerb.ar(Pan2.ar(SinOsc.ar(freq, input, LFNoise2.ar(rate)).fold2(Line.kr(0,1.01,8)),SinOsc.ar(panRate)), 100, 5, 0.1);
		env =EnvGen.ar(Env.asr(5, 1, 5),gate) ;
		env2 =EnvGen.ar(Env.asr(10, 1, 10),gate2, doneAction:2) ;

		Out.ar(out, Limiter.ar(sound *vol *env * env2, 0.9)); //vol was 0.05 then 0.1 then 0.08, now 0.09

	}).add;


	//bus/synth required for feedback

	SynthDef("bus_stereo_3", { arg out=0, in=34;

		var signal;

		signal = In.ar([in, in+1]);

		Out.ar(out, signal);

	}).add;


	//
	//~bus_clicks_3 = Synth("bus_stereo_3"); //execute first and let running
	//~clicks_3 = Synth(\clicks_3);


	//Synthesizer: clicks_3 for sample (Feedback synth)

	SynthDef(\clicks_3_for_Sample3, { arg out=50, in=50, freq =1300, rate =1, vol=0.08, feedbackVol =24, gate =1, panRate=0.1, gate2 =1;
		var input, sound, env, env2;
		input = InFeedback.ar(in, 1) * feedbackVol;
		sound = GVerb.ar(Pan2.ar(SinOsc.ar(freq, input, LFNoise2.ar(rate)).fold2(Line.kr(0,1.01,8)),SinOsc.ar(panRate)), 100, 5, 0.1);
		env =EnvGen.ar(Env.asr(5, 1, 5),gate) ;
		env2 =EnvGen.ar(Env.asr(10, 1, 10),gate2, doneAction:2) ;

		Out.ar(out, Limiter.ar(sound *vol *env * env2, 0.9)); //vol was 0.05 then 0.1 now 0.08

	}).add;

	//bus/synth required for feedback

	SynthDef("bus_stereo_5", { arg out=0, in=50;

		var signal;

		signal = In.ar([in, in+1]);

		Out.ar(out, signal);

	}).add;






	//Synthesizer: clicks_4 (Feedback synth)


	SynthDef(\clicks_4, { ////// old \sound3

		arg out=36, in=36, freq1 = 1600, freq2=635, rate =1, vol=0.09, feedbackVol =1, gate =1, panRate=0.1, gate2 =1;

		var sound;
		var oscs;
		var pan;
		var input;
		var env;
		var env2;




		input = InFeedback.ar(in, 1) * feedbackVol;

		oscs = SinOsc.ar((freq1 + freq2 )/2, input) * SinOsc.ar([freq1, freq2], input, LFNoise2.ar(rate))/*.fold2(Line.kr(0,1.01,8))*/;

		sound = GVerb.ar(oscs,100, 5, 0.1);


		pan = Pan2.ar(sound, SinOsc.ar(panRate));


		env =EnvGen.ar(Env.asr(5, 1, 5),gate) ;

		env2 =EnvGen.ar(Env.asr(10, 1, 10),gate2, doneAction:2) ; //vol was 0.05 then 0.1 then 0.08 now 0.09



		//SendReply.kr(Impulse.kr(200), '/amp', Amplitude.kr(comp)); //send data from server
		Out.ar(out, Limiter.ar(pan *vol *env* env2, 0.9));


	}).send;


	//bus/synth required for feedback
	SynthDef("bus_stereo_4", { arg out=0, in=36;

		var signal;

		signal = In.ar([in, in+1]);

		Out.ar(out, signal);

	}).add;





	//===========Set buses required for FEEDBACK SYNTHESIZERS

	~bus_clicks_1 = Synth("bus_stereo_1"); //execute first and let running
	~bus_clicks_2 = Synth("bus_stereo_2");//execute first and let running
	~bus_clicks_3 = Synth("bus_stereo_3"); //execute first and let running
	~bus_clicks_4 = Synth("bus_stereo_4"); //execute first and let running
	~bus_clicks_5 = Synth("bus_stereo_5");





	//Set sines initial parameters


	0.5.wait;


	~osc = Synth(\osc, [\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1]);




	{inf.do({

		~osc.set(\gate2, 0);

		rrand(10, 20).wait;

		~osc.set(\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1);

		rrand(10, 50).wait;


	});
	}.fork;



	~osc2 = Synth(\osc2, [\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1]);




	{inf.do({

		~osc2.set(\gate2, 0);

		rrand(10, 20).wait;

		~osc2.set(\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1);

		rrand(10, 50).wait;


	});
	}.fork;



	~osc3 = Synth(\osc3, [\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1]);




	{inf.do({

		~osc3.set(\gate2, 0);

		rrand(10, 20).wait;

		~osc3.set(\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1);

		rrand(10, 50).wait;


	});
	}.fork;




	~osc4 = Synth(\osc4, [\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1]);


	{inf.do({

		~osc4.set(\gate2, 0);

		rrand(10, 20).wait;

		~osc4.set(\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1);

		rrand(10, 50).wait;




	});
	}.fork;




	//================play/stop sounds


	0.5.wait;

	//play sines
	~osc.set(\gate, 1 );
	~osc2.set(\gate, 1 );
	~osc3.set(\gate, 1 );
	~osc4.set(\gate, 1 );

	//play drones

	~dronesRoutine = 	Routine({ loop{

		~drone = Synth(\drone1, [\attackSpeed, rrand(0.5, 40).postln, \amp, 0.6]);

		rrand(3, 15).wait;


		~drone.set(\gate, 0);

		rrand(3, 8).wait;}
	});
	//~dronesRoutine.play;





}}.fork;


)





//~dronesRoutine.stop;


//--------------- Tasks to control the playback processes and the change of synth parameters

~task1 = Task({

	loop{

		Ndef(\sample2, {


			var rate = [rrand(-0.9, -0.1), rrand(0.1, 0.4)].choose;

			~random2 = rrand(0, ~buffers.size -1);
			~sampleVolume_sample2 =0.5;



			Pan2.ar(


				FreeVerb.ar(PlayBuf.ar(~buffers[~random2].numChannels, ~buffers[~random2].bufnum, rate, startPos: ~buffers[~random2].numFrames-2 *(rate<0).binaryValue, doneAction: 2), 0.5)* ~sampleVolume_sample2, //volume was 0.6

				SinOsc.ar(Rand(0.01,1))) //panning


		}).play(0,2);



		rrand(60, 100).wait;
	}
});


//~task1.start;
//~task1.stop;



~task2 = Task({

	loop{


		~random3 = rrand(0, ~buffers.size -1);
		~sampleVolume_sample3 =0.5;

		Ndef(\sample3, {

			arg in=50;


			var rate = [rrand(-0.9, -0.1), rrand(0.1, 0.9)].choose; //rrand(-2.0, -5.0).postln;

			var pitchRatio = rrand(1, 4);

			var freq1 = rrand(400, 2000);

			var input =InFeedback.ar(in, 1);




			var buffer = PlayBuf.ar(~buffers[~random3].numChannels, ~buffers[~random3].bufnum, rate, startPos: ~buffers[~random3].numFrames-2 *(rate<0).binaryValue, doneAction: 0);

			var osc = SinOsc.ar(freq1, PitchShift.ar(input, 0.2,pitchRatio) );


			var signal = Pan2.ar(FreeVerb.ar(PitchShift.ar(buffer * osc, 0.5), 0.8, 1)* ~sampleVolume_sample3, //volume was 0.6

				SinOsc.ar(Rand(0.01,1)));

			//
			DetectSilence.ar( signal, 0.001, 1, doneAction:2); //panning

			signal;



		}).play(0,2);

		//30.wait;
		//Ndef(\sample3).free;
		rrand(60, 180).wait;

	}
});

~task2.start;
//~task2.stop;




~task3 = Task({

	loop{

		Ndef(\sample2, {


			var rate = rrand(-1, -0.85).postln;

			~random2 = rrand(0, ~buffers.size -1);
			~sampleVolume_sample3 =0.3;



			Pan2.ar(


				FreeVerb.ar(PlayBuf.ar(~buffers[~random2].numChannels, ~buffers[~random2].bufnum, rate, startPos: ~buffers[~random2].numFrames-2 *(rate<0).binaryValue, doneAction: 2), 0.5)* ~sampleVolume_sample3, //volume was 0.6

				SinOsc.ar(Rand(0.01,1))) //panning


		}).play(0,2);



		rrand(30, 60).wait;
	}
});


//~task3.start;
//~task3.stop;
